/*
    Copyright (c) 2011, 2011 aizo ag, Zurich, Switzerland

    Author: Sergey 'Jin' Bostandzhyan <jin@dev.digitalstrom.org>

    This file is part of dS Assistant.

    dS-Assistant is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    dS-Assistant is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with digitalSTROM Server. If not, see <http://www.gnu.org/licenses/>.

*/

#ifndef __DSA_HTML_WEB_HANDLER_H__
#define __DSA_HTML_WEB_HANDLER_H__

#include "web_handler.h"
#include <string>

namespace dSA
{

class HTMLWebHandler : public WebHandler
{
public:
    HTMLWebHandler(struct mg_connection* connection,
                   const struct mg_request_info* request_info);
    virtual void process() = 0;
protected:
    void failure(const std::string title, const std::string message);
    std::string page_begin(const std::string title, bool download = false);
    std::string page_end();
    std::string table_begin(bool border = false);
    std::string table_row_begin();
    std::string table_row_end();
    std::string table_row_simple(const std::string c1, const std::string c2);
    std::string table_end();
    std::string table_column_add(const std::string text,
                                 const unsigned short colspan = 0,
                                 const unsigned short width = 0);
    std::string table_header(const std::string text);
    std::string table_caption(const std::string text);
    std::string error(const std::string text);
    std::string header(const std::string text);
};

}; // namespace

#endif//__DSA_HTML_WEB_HANDLER_H__

